VERSION 5.00
Begin VB.UserControl ScalableTextBox 
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   4185
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5475
   ControlContainer=   -1  'True
   ScaleHeight     =   4185
   ScaleWidth      =   5475
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   2940
      Top             =   2340
   End
   Begin VB.PictureBox cPic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  '
      Height          =   225
      Left            =   3240
      ScaleHeight     =   225
      ScaleWidth      =   150
      TabIndex        =   2
      Top             =   3210
      Visible         =   0   'False
      Width           =   150
   End
   Begin VB.PictureBox pbText 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  '
      Height          =   1815
      Left            =   0
      MousePointer    =   3  'I-
      ScaleHeight     =   1815
      ScaleWidth      =   2895
      TabIndex        =   0
      ToolTipText     =   "pbtext"
      Top             =   0
      Width           =   2895
   End
   Begin VB.TextBox Dummy 
      BorderStyle     =   0  '
      Height          =   3285
      Left            =   210
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "ScalableMultilineTextBox.ctx":0000
      Top             =   1950
      Width           =   2655
   End
   Begin VB.Line cLine 
      X1              =   1560
      X2              =   1560
      Y1              =   2310
      Y2              =   2700
   End
End
Attribute VB_Name = "ScalableTextBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Event MouseWheel(ByVal Steps As Single, ByVal Shift As Integer)
Event NativeModeSwitch(VMode As Boolean)

Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal HWND As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal HWND As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal HWND As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function SetCapture Lib "user32" (ByVal HWND As Long) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal HWND As Long, lpRect As RECT, ByVal bErase As Long) As Long

Private Const WM_PRINT As Long = &H317
Private Const WM_PRINTCLIENT As Long = &H318

Private Const PRF_CHECKVISIBLE = &H1
Private Const PRF_NONCLIENT = &H2
Private Const PRF_CLIENT = &H4
Private Const PRF_ERASEBKGND = &H8
Private Const PRF_CHILDREN = &H10
Private Const PRF_OWNED = &H20

Private Const WM_SETFOCUS       As Long = &H7
Private Const WM_KEYFIRST       As Long = &H100&
Private Const WM_KEYLAST        As Long = &H108&
Private Const WM_MOUSEFIRST     As Long = &H200&
Private Const WM_MOUSELAST      As Long = &H209&
Private Const WM_CAPTURECHANGED As Long = &H215

Private Const WM_MOUSEMOVE          As Long = &H200
Private Const WM_LBUTTONDOWN        As Long = &H201&
Private Const WM_LBUTTONUP          As Long = &H202&
Private Const WM_RBUTTONDOWN        As Long = &H204&
Private Const WM_RBUTTONUP          As Long = &H205&
Private Const WM_MBUTTONDOWN        As Long = &H207&
Private Const WM_MBUTTONUP          As Long = &H208&
Private Const WM_MOUSEWHEEL         As Long = &H20A

Private Const MK_CONTROL            As Long = &H8
Private Const MK_SHIFT              As Long = &H4

Private m_fDesignModeTested     As Boolean
Private m_fInDesignMode         As Boolean
Private m_hBackbuffer           As Long
Private m_OrigWidth             As Single
Private m_OrigHeight            As Single
Private m_pxOrigWidth           As Long
Private m_pxOrigHeight          As Long
Private m_WheelAccumulator      As Long
Private m_ViewMode As Long
Public NativeMode As Boolean
Private WithEvents MsgFilter    As CUniWindowMsgFilter
Attribute MsgFilter.VB_VarHelpID = -1
Private WithEvents DummyFilter  As CUniWindowMsgFilter
Attribute DummyFilter.VB_VarHelpID = -1

Private Type RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type
Private Type CaretPosType
    l As Long
    T As Long
    w As Long
    H As Long
    color As Long
End Type
Private Type unpacked_xy
    x As Integer
    y As Integer
End Type

Private Type UNPACKED_KD
    Keys    As Integer
    zDelta  As Integer
End Type

Private Type PACKED_DW
    dw As Long
End Type

Private Const EM_POSFROMCHAR = &HD6 '   
Private Type POINTAPI
     x As Long
     y As Long
End Type

Private Declare Function GetCaretPos Lib "user32" (IpPoint As POINTAPI) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
  Dest As Any, Source As Any, ByVal cbCopy As Long)
Private Declare Function CreateCaret Lib "user32" (ByVal HWND As Long, ByVal hBitmap As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function DestroyCaret& Lib "user32" ()
Private Declare Function ShowCaret Lib "user32" (ByVal HWND As Long) As Long
Private Declare Function GetFocus& Lib "user32" ()
Private Declare Function SetCaretPos& Lib "user32" (ByVal x As Long, ByVal y As Long)
Private Declare Function HideCaret& Lib "user32" (ByVal HWND As Long)
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function GetTextExtentPoint32& Lib "gdi32" Alias "GetTextExtentPoint32A" _
(ByVal hdc As Long, ByVal Ipsz As String, ByVal cbString As Long, IpSize As POINTAPI)
Private Declare Function GetFocusAPI& Lib "user32" Alias "GetFocus" ()
Dim CursorHeight As Single
 Private Declare Function GetClientRect Lib "user32" (ByVal hwind As Long, WRect As RECT) As Long
 Private UCclientWidth As Long '  usercontrol
 Private Const SRCCOPY = &HCC0020
 Private Const WHITENESS = &HFF0062
 Private Const BLACKNESS = &O0
 Private Const DSTINVERT = &H550009
Private Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal  As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long)
Dim CaretPos As CaretPosType '     
Dim invert As Boolean '    
Dim noPaintCaret As Boolean
Public Property Get WidthClient() As Long
'  usercontrol
'  usercontrol  borderstyle=0,        
    Dim Coord As RECT
Call GetClientRect(UserControl.HWND, Coord)
WidthClient = Coord.right * Screen.TwipsPerPixelX
End Property
Public Property Get WidthClientEffective() As Long
' ,  scaleleft <>0
    Dim Coord As RECT
Call GetClientRect(UserControl.HWND, Coord)
WidthClientEffective = Coord.right * Screen.TwipsPerPixelX + ScaleLeft
End Property
Public Property Get HeightClient() As Long
'  usercontrol
'  usercontrol  borderstyle=0,        
    Dim Coord As RECT
Call GetClientRect(UserControl.HWND, Coord)
HeightClient = Coord.bottom * Screen.TwipsPerPixelY
End Property

Public Property Get ControlHWND() As Long
    ControlHWND = UserControl.HWND
End Property
Public Property Get HWND() As Long
    HWND = Dummy.HWND
End Property
Public Property Get Text() As String
    Text = Dummy.Text
End Property
Public Property Let Text(txt As String)
    Dummy.Text = txt
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get SelStart() As Long
    SelStart = Dummy.SelStart
End Property
Public Property Let SelStart(position As Long)
    Dummy.SelStart = position
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get SelLength() As Long
    SelLength = Dummy.SelLength
End Property
Public Property Let SelLength(position As Long)
    Dummy.SelLength = position
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get SelText() As String
    SelText = Dummy.SelText
End Property
Public Property Let SelText(txt As String)
    Dummy.SelText = txt
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get FontSize() As Single
    FontSize = Dummy.FontSize
End Property
Public Property Let FontSize(value As Single)
    Dummy.FontSize = value
    ScalableCaretHeight
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get FontName() As String
    FontName = Dummy.FontName
End Property
Public Property Let FontName(txt As String)
    Dummy.FontName = txt
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get BackColor() As Long
    BackColor = Dummy.BackColor
End Property
Public Property Let BackColor(value As Long)
    Dummy.BackColor = value
    UserControl.BackColor = value
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get ForeColor() As Long
    ForeColor = Dummy.ForeColor
End Property
Public Property Let ForeColor(value As Long)
    Dummy.ForeColor = value
    CaretPos.color = Dummy.ForeColor
     If Not NativeMode Then pbText_Paint
End Property
Public Property Get ToolTipString() As String
    ToolTipString = pbText.ToolTipText

End Property
Public Property Let ToolTipString(txt As String)
    pbText.ToolTipText = txt
    Dummy.ToolTipText = txt
End Property
Public Property Get Locked() As Boolean
    Locked = Dummy.Locked
End Property
Public Property Let Locked(value As Boolean)
    Dummy.Locked = value
End Property

Public Property Get OriginalWidth() As Single
    OriginalWidth = m_OrigWidth
End Property

Public Property Get OriginalHeight() As Single
    OriginalHeight = m_OrigHeight
End Property
Public Property Get ViewMode() As Long
'3-   ,  1 -   , 0-     ( )
    ViewMode = m_ViewMode
End Property
Private Function TryCancelFilteringInDesignMode() As Boolean
    On Error Resume Next
    If Not m_fDesignModeTested Then
        m_fInDesignMode = Not Ambient.UserMode
        m_fDesignModeTested = True
    End If
    
    If m_fInDesignMode Then
        Set MsgFilter = New CUniWindowMsgFilter
        Set DummyFilter = New CUniWindowMsgFilter
    End If
    TryCancelFilteringInDesignMode = m_fInDesignMode
End Function

Private Sub TryApplyFilteringInUserMode()
    On Error Resume Next
    If Ambient.UserMode And m_fInDesignMode Then
        MsgFilter.WindowHandle = pbText.HWND
        DummyFilter.WindowHandle = Dummy.HWND
        m_fInDesignMode = False
    End If
End Sub


Public Property Let OriginalWidth(ByVal nv As Single)
'  
    If nv <> m_OrigWidth Then
        m_OrigWidth = nv
        TrySetNativeMode (True)
        HandleDummyResize
         If Not NativeMode Then pbText_Paint
    End If
End Property

Public Property Let OriginalHeight(ByVal nv As Single)
'  
    If nv <> m_OrigHeight Then
        m_OrigHeight = nv
        TrySetNativeMode (True)
        HandleDummyResize
        If Not NativeMode Then pbText_Paint
    End If
End Property


Private Sub HandleDummyResize()
'  
    Dummy.Move 0, 0, m_OrigWidth, m_OrigHeight
'      
    m_pxOrigWidth = pbText.ScaleX(m_OrigWidth, pbText.ScaleMode, vbPixels)
    m_pxOrigHeight = pbText.ScaleY(m_OrigHeight, pbText.ScaleMode, vbPixels)
    
If NativeMode Then Exit Sub

    Dim hCompatBitmap As Long
    Dim hBackbuffer   As Long
    ' ,   usercontrol-,   
    hCompatBitmap = CreateCompatibleBitmap( _
        pbText.hdc, _
        m_pxOrigWidth + 1, _
        m_pxOrigHeight + 1)
    
    If hCompatBitmap = 0 Then
        Error 7
    End If
    '  ,   usercontrol-
    hBackbuffer = CreateCompatibleDC(pbText.hdc)
    If hBackbuffer = 0 Then
        DeleteObject hCompatBitmap
        Error 7
    End If
    '    
    If SelectObject(hBackbuffer, hCompatBitmap) = 0 Then
        DeleteObject hCompatBitmap
        DeleteObject hBackbuffer
        Error 7
    End If
    
    DeleteObject hCompatBitmap
    
    If m_hBackbuffer <> 0 Then
        DeleteObject m_hBackbuffer '       
    End If
    m_hBackbuffer = hBackbuffer '       
    


ScalableCaretHeight '  
End Sub

Private Sub Dummy_KeyDown(KeyCode As Integer, Shift As Integer)

    pbText_Paint
End Sub

Private Sub Dummy_KeyPress(KeyAscii As Integer)

    pbText_Paint
End Sub

Private Sub Dummy_KeyUp(KeyCode As Integer, Shift As Integer)

    pbText_Paint
End Sub

Private Sub Dummy_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
pbText_Paint
End Sub

Private Sub DummyFilter_evtSetFocus(msg As Long, wParam As Long, lParam As Long)
'Call RunCaret
End Sub

Private Sub DummyFilter_OnMessage(msg As Long, wParam As Long, lParam As Long, bCancel As Boolean)
    If TryCancelFilteringInDesignMode Then Exit Sub
    Select Case msg
        Case WM_RBUTTONUP
            ' This message causes display of context menu, and to let
            ' context menu show in proper location, we do NOT compensate.
            noPaintCaret = True '       (     ,  )    
            Call SetFocusAPI(Dummy.HWND) '     ,    ,    ,        
            noPaintCaret = False
'            If Dummy.SelLength <> 0 Then Call pbText_Paint
            pbText_Paint
        Case WM_MOUSEFIRST To WM_MOUSELAST

            ' Other mouse-related message require compensation:
            lParam = CompensateXyForScaling(lParam) '    
    End Select
    
    Select Case msg
        Case WM_MOUSEWHEEL '     
            If Ambient.UserMode Then
                HandleWheelMsg wParam, lParam
                bCancel = True
            End If
        Case WM_MOUSEMOVE
            'PostMessage UserControl.hwnd, &HF, UserControl.hdc, ByVal 0
                    Dim ks As Integer

                    ks = GetKeyState(vbKeyLButton) '

                    If Not CBool(ks And &H8000) Then: bCancel = True: Exit Sub '     
'                    End If
            Dim r As RECT
            r.bottom = 1
            r.right = 1
            InvalidateRect pbText.HWND, r, 0
        Case &H215
           ' SetCapture UserControl.hwnd
        Case 7 'setfocus
        Timer1.Enabled = True
        noPaintCaret = True '       (     ,  )    
       pbText_Paint
       noPaintCaret = False
'                       bCancel = True
        Exit Sub
        Case 8 'killfocus

    End Select
'    Debug.Print "dummy msg: ", msg
End Sub

Private Function CompensateXyForScaling(ByVal msg_lparam As Long) As Long
'     picturebox    textbox
If NativeMode Then CompensateXyForScaling = msg_lparam: Exit Function '       
    Dim xy_packed   As PACKED_DW
    Dim xy_unpacked As unpacked_xy
    
    xy_packed.dw = msg_lparam
    LSet xy_unpacked = xy_packed
    xy_unpacked.x = xy_unpacked.x / (pbText.Width / m_OrigWidth) '
    xy_unpacked.y = xy_unpacked.y / (pbText.Height / m_OrigHeight)
    LSet xy_packed = xy_unpacked
    CompensateXyForScaling = xy_packed.dw
End Function

Private Sub MsgFilter_OnMessage(msg As Long, wParam As Long, lParam As Long, bCancel As Boolean)
'If NativeMode Then Exit Sub

    If TryCancelFilteringInDesignMode Then Exit Sub

    Select Case msg
        Case WM_KEYFIRST To WM_KEYLAST
            SendMessage Dummy.HWND, msg, wParam, ByVal lParam '   
        Case WM_RBUTTONUP 'new

                    PostMessage Dummy.HWND, msg, wParam, ByVal lParam '   

            bCancel = True
        Case WM_MOUSEFIRST To WM_MOUSELAST

            PostMessage Dummy.HWND, msg, wParam, ByVal lParam '   

            bCancel = True
        Case WM_MOUSEWHEEL
            If Ambient.UserMode Then
                HandleWheelMsg wParam, lParam '    (    )
                bCancel = True
            End If
        Case 7 'WM_SETFOCUS



        Case 8 'WM_KILLFOCUS

        Case Else
           ' Debug.Print msg
    End Select
'        Debug.Print "pbtext msg: ", msg
End Sub

Private Sub HandleWheelMsg(ByVal wParam As Long, ByVal lParam As Long)
'   
    Const WHEEL_DELTA As Long = 120
    Dim packed_info As PACKED_DW: packed_info.dw = wParam
    Dim packed_xy   As PACKED_DW: packed_xy.dw = lParam
    Dim unpacked_info As UNPACKED_KD: LSet unpacked_info = packed_info
    Dim unpacked_xy   As unpacked_xy: LSet unpacked_xy = packed_xy
    
    m_WheelAccumulator = m_WheelAccumulator + unpacked_info.zDelta
    
    If Abs(m_WheelAccumulator) < WHEEL_DELTA Then Exit Sub
    
    Dim ShiftFlags As Long
    Dim nSteps As Long: nSteps = m_WheelAccumulator \ WHEEL_DELTA
    m_WheelAccumulator = m_WheelAccumulator Mod WHEEL_DELTA
    
    
    If unpacked_info.Keys And MK_CONTROL Then ShiftFlags = ShiftFlags Or vbCtrlMask
    If unpacked_info.Keys And MK_SHIFT Then ShiftFlags = ShiftFlags Or vbShiftMask
'    DestroyCaret
    RaiseEvent MouseWheel(nSteps, ShiftFlags) '   

End Sub


Private Sub Dummy_GotFocus()
Timer1.Enabled = True
End Sub

Private Sub pbText_GotFocus()
Dummy.SetFocus '      

pbText_Paint
End Sub

Private Sub pbText_Resize()
pbText.FontSize = Dummy.FontSize
End Sub

Private Sub Timer1_Timer()

If NativeMode Then Exit Sub
Dim cF As Long
cF = GetFocusAPI
'If (cF = pbText.HWND) Then Debug.Print "Pbox focused----------------------------(timer)", Time
If (cF <> pbText.HWND) And (cF <> Dummy.HWND) Then pbText_Paint: Timer1.Enabled = False: Exit Sub

'====================bitblt
Dim dX As Long, dY As Long, picWidth As Long, picHeight As Long

If invert Then 'True
invert = False
dX = CaretPos.l / Screen.TwipsPerPixelX
dY = CaretPos.T / Screen.TwipsPerPixelY
picWidth = CaretPos.w / Screen.TwipsPerPixelX
picHeight = CaretPos.H / Screen.TwipsPerPixelY
Dim PaintColor As Long
PaintColor = DSTINVERT 'BLACKNESS'WHITENESS
'PaintColor = IIf(Dummy.SelLength <> 0, WHITENESS, DSTINVERT)
Call BitBlt(pbText.hdc, dX, dY, picWidth, picHeight, pbText.hdc, dX, dY, PaintColor)

Else 'False

dX = CaretPos.l / Screen.TwipsPerPixelX
dY = CaretPos.T / Screen.TwipsPerPixelY
picWidth = CaretPos.w / Screen.TwipsPerPixelX
picHeight = CaretPos.H / Screen.TwipsPerPixelY
Call BitBlt(pbText.hdc, dX, dY, picWidth, picHeight, cPic.hdc, 0, 0, SRCCOPY)

invert = True
End If

End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
    Select Case PropertyName
        Case "UserMode"
            If Ambient.UserMode Then
                TryApplyFilteringInUserMode
            Else
                TryCancelFilteringInDesignMode
            End If
    End Select
End Sub

Private Sub UserControl_Initialize()
m_ViewMode = 3 '     
'ScaleLeft = -20
Dummy.left = 0: Dummy.top = 0
pbText.left = 0: pbText.top = 0
CaretPos.color = Dummy.ForeColor
   '  
    Set MsgFilter = New CUniWindowMsgFilter
    Set DummyFilter = New CUniWindowMsgFilter
    
    ' .      1 (AND)
    SetStretchBltMode pbText.hdc, 4 '4 -  (     /,   )

    ' 
    On Error Resume Next
    Err.Clear
    MsgFilter.WindowHandle = pbText.HWND
If Err.Number <> 0 Then m_ViewMode = m_ViewMode - 2     '  -   " "   (   )
     Err.Clear
    DummyFilter.WindowHandle = Dummy.HWND
    If Err.Number <> 0 Then m_ViewMode = m_ViewMode - 1 '  -         
End Sub

Private Sub UserControl_Terminate()
    If m_hBackbuffer <> 0 Then
        DeleteObject m_hBackbuffer '  
        m_hBackbuffer = 0 ' 
    End If
    
    Set DummyFilter = Nothing '  
    Set MsgFilter = Nothing
End Sub


Private Sub UserControl_InitProperties()

UserControl
    m_OrigWidth = pbText.Width
    m_OrigHeight = pbText.Height
    HandleDummyResize
    

End Sub

Private Sub pbText_KeyDown(KeyCode As Integer, Shift As Integer)
    pbText_Paint
End Sub

Private Sub pbText_KeyPress(KeyAscii As Integer)
    pbText_Paint
End Sub

Private Sub pbText_KeyUp(KeyCode As Integer, Shift As Integer)
    pbText_Paint
End Sub

Private Sub pbText_Paint()
If NativeMode Then Exit Sub
'   :
'On Error GoTo endcount
'Static countPaint As Long
'countPaint = countPaint + 1
'endcount:
        Debug.Print "paint====", countPaint, "========="
    Call SendMessage(Dummy.HWND, _
                     WM_PRINT, _
                     m_hBackbuffer, _
                     ByVal PRF_ERASEBKGND Or PRF_NONCLIENT Or PRF_CLIENT)
    '       :
    StretchBlt pbText.hdc, _
        0, _
        0, _
        pbText.ScaleX(pbText.Width, pbText.ScaleMode, vbPixels), _
        pbText.ScaleY(pbText.Height, pbText.ScaleMode, vbPixels), _
        m_hBackbuffer, _
        0, 0, _
        m_pxOrigWidth, _
        m_pxOrigHeight, _
        vbSrcCopy

RunCaret '  
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_OrigWidth = PropBag.ReadProperty("OriginalWidth", pbText.Width)
    m_OrigHeight = PropBag.ReadProperty("OriginalHeight", pbText.Height)
    HandleDummyResize
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "OriginalWidth", m_OrigWidth, pbText.Width
    PropBag.WriteProperty "OriginalHeight", m_OrigHeight, pbText.Height
End Sub


Private Sub UserControl_Resize()
Dim Coord As RECT
TrySetNativeMode
On Error GoTo exitResize
If Not NativeMode Then
Call GetClientRect(UserControl.HWND, Coord)
UCclientWidth = Coord.right * Screen.TwipsPerPixelX
pbText.Width = UCclientWidth + ScaleLeft
pbText.Height = Coord.bottom * Screen.TwipsPerPixelY
'UserControl_InitProperties
    ScalableCaretHeight '        CaretPos
    pbText_Paint
    End If
exitResize:
End Sub

Private Sub RunCaret0(Optional ByVal createNew As Boolean)
' 
'      selstart.    ,     
'(    " "       , ..     selstart   ..)
'    selstart      .              ,     ,    ,   , selstart   
 ' -  
        Dim CarSou As POINTAPI
        Dim CarNew As POINTAPI
        Dim cRes As Long
        Dim dss As Long
        Dim cF As Long
        Dim posChange As Boolean '   
cF = GetFocusAPI
If (cF <> pbText.HWND) And (cF <> Dummy.HWND) Then Exit Sub

        Dim newLine As Boolean '    chr10
        On Error GoTo ex

        Dim cX As Integer, cY As Integer

        dss = Dummy.SelStart + Dummy.SelLength '     . . 

        If Len(Dummy.Text) <> 0 Then '     
                Dim AddDelta As Long
                '    -    
                If dss = (Len(Dummy.Text)) And (Mid(Dummy.Text, Len(Dummy.Text), 1) <> Chr(10)) Then
                    dss = dss - 1:
                    AddDelta = pbText.TextWidth(Mid(Dummy.Text, Len(Dummy.Text), 1)) * (pbText.Width / Dummy.Width)
                '    -   
                ElseIf dss = (Len(Dummy.Text)) And (Mid(Dummy.Text, Len(Dummy.Text), 1) = Chr(10)) Then
                    dss = dss - 1
                    newLine = True
                    
'                Else ' ,     " "       
'                    dss = dss - 1
'                    AddDelta = pbText.TextWidth(Mid(Dummy.Text, dss + 1, 1)) * (pbText.Width / Dummy.Width)
                End If
                
                ' EM_POSFROMCHAR    
                cRes = SendMessage(Dummy.HWND, EM_POSFROMCHAR, dss, 0) '       
                Call CopyMemory(cX, cRes, 2)
                Call CopyMemory(cY, ByVal (VarPtr(cRes) + 2), 2) '      
                '     (..    ) , SendMessage  -1 -1 (         )

                If newLine Then cX = 0: cY = cY + GetStringHeight
        Else 'Len(Dummy.Text) = 0
                cX = 0: cY = 0
        End If
        CarSou.x = cX: CarSou.y = cY '     

        CarNew.x = CarSou.x * (pbText.Width / Dummy.Width) + (AddDelta / Screen.TwipsPerPixelX) ' * Screen.TwipsPerPixelX
        CarNew.y = CarSou.y * (pbText.Height / Dummy.Height) '* Screen.TwipsPerPixelY
'        Debug.Print "PictureBox:  X-  =", CarNew.x, "Y-  =", CarNew.y '     picturebox


Dim l As Long, T As Long, H As Long 'as Single

'Debug.Print ".-  : ", CaretPos.L
'Debug.Print ".-  : ", CarNew.x * Screen.TwipsPerPixelX, "( )"
l = IIf((CarNew.x * Screen.TwipsPerPixelX) >= UCclientWidth, UCclientWidth - 10, IIf((CarNew.x * Screen.TwipsPerPixelX) <= 0, 10, CarNew.x * Screen.TwipsPerPixelX - CaretPos.w)):
If CaretPos.l <> l Then
    posChange = True

    CaretPos.l = l

Else:  End If
T = CarNew.y * Screen.TwipsPerPixelY
If CaretPos.T <> T Then
    posChange = True

    CaretPos.T = T:
   
Else:  End If

Dim sX As Long, sY As Long, picWidth As Long, picHeight As Long

sX = CaretPos.l / Screen.TwipsPerPixelX
sY = CaretPos.T / Screen.TwipsPerPixelY
picWidth = CaretPos.w / Screen.TwipsPerPixelX
picHeight = CaretPos.H / Screen.TwipsPerPixelY
Call BitBlt(cPic.hdc, 0, 0, picWidth, picHeight, pbText.hdc, sX, sY, SRCCOPY) '    

Dim dX As Long, dY As Long

dX = CaretPos.l / Screen.TwipsPerPixelX
dY = CaretPos.T / Screen.TwipsPerPixelY
Call BitBlt(pbText.hdc, dX, dY, picWidth, picHeight, pbText.hdc, 0, 0, DSTINVERT) '   
invert = True '      

ex:

End Sub
Private Sub RunCaret(Optional ByVal createNew As Boolean)
If noPaintCaret Then Exit Sub
'    GetCaretPos
'            ,  )
'    ,     , GetCaretPos        ,   ,     
'Debug.Print "Entering RunCaret", Time
    Dim CarSou As POINTAPI
        Dim CarNew As POINTAPI
        Dim cRes As Long
        Dim cF As Long
        Dim posChange As Boolean '   
cF = GetFocusAPI
'     Tab:
If (cF = pbText.HWND) Then Dummy.SetFocus
'If (cF <> pbText.HWND) And (cF <> Dummy.HWND) Then Exit Sub
If (cF <> Dummy.HWND) Then Exit Sub

        On Error GoTo ex

        Dim cX As Integer, cY As Integer
'        Debug.Print "RunCaret - call GetCaretPos"
        cRes = GetCaretPos(CarSou) '    
'        Debug.Print "Result call GetCaretPos is", cRes
        CarNew.x = CarSou.x * (pbText.Width / Dummy.Width)  ' * Screen.TwipsPerPixelX
        CarNew.y = CarSou.y * (pbText.Height / Dummy.Height) '* Screen.TwipsPerPixelY
'        Debug.Print "RunCaret: PictureBox:  X-px=", CarNew.x, "Y-px=", CarNew.y '     picturebox

Dim l As Long, T As Long, H As Long 'as Single

'Debug.Print ".-  : ", CaretPos.L
'Debug.Print ".-  : ", CarNew.x * Screen.TwipsPerPixelX, "( )"
l = IIf((CarNew.x * Screen.TwipsPerPixelX) >= UCclientWidth, UCclientWidth - 10, IIf((CarNew.x * Screen.TwipsPerPixelX) <= 0, 10, CarNew.x * Screen.TwipsPerPixelX - (CaretPos.w / 2))):
If CaretPos.l <> l Then
    posChange = True
    '-   
    CaretPos.l = l
Else:  End If
'Debug.Print "Picturebox:  X-  ", CaretPos.L, "( )"

'Debug.Print ".Y-  : ", CaretPos.T
'Debug.Print ".Y-  : ", CarNew.y * Screen.TwipsPerPixelY
T = CarNew.y * Screen.TwipsPerPixelY
If CaretPos.T <> T Then
    posChange = True
    '-   
    CaretPos.T = T:
Else:  End If
'Debug.Print "Picturebox:  Y-  ", CaretPos.T


Dim sX As Long, sY As Long, picWidth As Long, picHeight As Long
'If posChange Then '     -     
sX = CaretPos.l / Screen.TwipsPerPixelX
sY = CaretPos.T / Screen.TwipsPerPixelY
picWidth = CaretPos.w / Screen.TwipsPerPixelX
picHeight = CaretPos.H / Screen.TwipsPerPixelY
Call BitBlt(cPic.hdc, 0, 0, picWidth, picHeight, pbText.hdc, sX, sY, SRCCOPY) '    

'End If

Dim dX As Long, dY As Long ', picWidth As Long, picHeight As Long

dX = CaretPos.l / Screen.TwipsPerPixelX
dY = CaretPos.T / Screen.TwipsPerPixelY
Call BitBlt(pbText.hdc, dX, dY, picWidth, picHeight, pbText.hdc, 0, 0, DSTINVERT) '   
invert = True '      
'Debug.Print "Paint caret color:", CaretPos.color
'Debug.Print "RunCaret is full execute; exit", Time
Exit Sub
ex:
Debug.Print "RunCaret ERROR; exit", Time
End Sub
Private Function GetStringHeight()
'      
       Dim out As Long
       Dim StrExtent As POINTAPI
       pbText.FontSize = Dummy.FontSize
       out = GetTextExtentPoint32(pbText.hdc, Chr(10), 1, StrExtent)
       GetStringHeight = StrExtent.y
End Function
Private Sub ScalableCaretHeight()
If NativeMode = True Then Exit Sub
'  CaretPos   long,       ,  long
CaretPos.w = 15 '  
Dim cHeightBase As Long
cHeightBase = GetStringHeight * Screen.TwipsPerPixelY '   ( )
Dim o_Height As Single
o_Height = IIf(m_OrigHeight = 0, pbText.Height, m_OrigHeight) '    
        CursorHeight = cHeightBase * (pbText.Height / o_Height)  '
        If cPic.Height <> CursorHeight Then
       CaretPos.H = CursorHeight:
       cPic.Height = CursorHeight
       Else: CaretPos.H = CursorHeight: End If
End Sub
Private Sub TrySetNativeMode(Optional ByVal NoResize As Boolean)
'      ( )   ,  
'noResize -    HandleDummyResize (         )
 If (Abs(m_OrigWidth - WidthClientEffective) < (WidthClientEffective / 100)) And (Abs(m_OrigHeight - HeightClient) < (HeightClient / 100)) Then
If Not NativeMode Then RaiseEvent NativeModeSwitch(True)
NativeMode = True
pbText.Visible = False
'MsgBox "Native mode"
Else
If NativeMode Then RaiseEvent NativeModeSwitch(False)
NativeMode = False
pbText.Visible = True
If Not NoResize Then HandleDummyResize
End If
End Sub
